Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
BoundingBox Class Reference

An axis-aligned bounding box; that is, a minimum and maximum coordinate triple. More...

`#include "boundingBox.h"`

Inheritance diagram for BoundingBox:

## Public Member Functions
| BoundingBox ()
| Constructs an empty box object.
| BoundingBox (const LPoint3 &min, const LPoint3 &max)
| Constructs a specific box object.
virtual const BoundingBox * | as_bounding_box () const
| Virtual downcast method.
virtual TypeHandle | force_init_type ()
virtual LPoint3 | get_approx_center () const
virtual LPoint3 | get_max () const
const LPoint3 & | get_maxq () const
| An inline accessor for the maximum value.
virtual LPoint3 | get_min () const
const LPoint3 & | get_minq () const
| An inline accessor for the minimum value.
int | get_num_planes () const
int | get_num_points () const
LPlane | get_plane (int n) const
LPoint3 | get_point (int n) const
virtual TypeHandle | get_type () const
virtual PN_stdfloat | get_volume () const
virtual BoundingVolume * | make_copy () const
virtual void | output (std::ostream &out) const
void | set_min_max (const LPoint3 &min, const LPoint3 &max)
| Sets the min and max point of the rectangular solid.
virtual void | xform (const LMatrix4 &mat)
Public Member Functions inherited from FiniteBoundingVolume
virtual const FiniteBoundingVolume * | as_finite_bounding_volume () const
| Virtual downcast method.
Public Member Functions inherited from GeometricBoundingVolume
bool | around (const GeometricBoundingVolume **first, const GeometricBoundingVolume **last)
| Resets the volume to enclose only the volumes indicated.
bool | around (const LPoint3 *first, const LPoint3 *last)
| Resets the volume to enclose only the points indicated.
virtual const GeometricBoundingVolume * | as_geometric_bounding_volume () const final
| Virtual downcast method.
virtual GeometricBoundingVolume * | as_geometric_bounding_volume () final
| Virtual downcast method.
int | contains (const GeometricBoundingVolume *vol) const
| Returns the appropriate set of IntersectionFlags to indicate the amount of intersection with the indicated volume.
int | contains (const LPoint3 &a, const LPoint3 &b) const
| Returns the appropriate set of IntersectionFlags to indicate the amount of intersection with the indicated line segment.
int | contains (const LPoint3 &point) const
| Returns the appropriate set of IntersectionFlags to indicate the amount of intersection with the indicated point.
bool | extend_by (const GeometricBoundingVolume *vol)
| Increases the size of the volume to include the given volume.
bool | extend_by (const LPoint3 &point)
| Increases the size of the volume to include the given point.
Public Member Functions inherited from BoundingVolume
bool | around (const BoundingVolume **first, const BoundingVolume **last)
| Resets the volume to enclose only the volumes indicated.
virtual const BoundingHexahedron * | as_bounding_hexahedron () const
| Virtual downcast method.
virtual const BoundingLine * | as_bounding_line () const
| Virtual downcast method.
virtual const BoundingPlane * | as_bounding_plane () const
| Virtual downcast method.
virtual const BoundingSphere * | as_bounding_sphere () const
| Virtual downcast method.
int | contains (const BoundingVolume *vol) const
| Returns the appropriate set of IntersectionFlags to indicate the amount of intersection with the indicated volume.
bool | extend_by (const BoundingVolume *vol)
| Increases the size of the volume to include the given volume.
bool | is_empty () const
| Any kind of volume might be empty.
bool | is_infinite () const
| The other side of the empty coin is an infinite volume.
void | set_infinite ()
| Marks the volume as infinite, even if it is normally finite.
virtual void | write (std::ostream &out, int indent_level=0) const
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from FiniteBoundingVolume
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from GeometricBoundingVolume
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from BoundingVolume
static TypeHandle | get_class_type ()
static void | init_type ()
static BoundsType | string_bounds_type (const std::string &str)
| Returns the BoundsType corresponding to the indicated string.
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| get_num_planes
| Returns 6: the number of faces of a rectangular solid.
| get_num_points
| Returns 8: the number of vertices of a rectangular solid.
| get_plane
| Returns the nth face of the rectangular solid.
| get_point
| Returns the nth vertex of the rectangular solid.
Public Attributes inherited from FiniteBoundingVolume
| get_max
| get_min
| get_volume
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Friends
class | BoundingSphere

## Additional Inherited Members
Public Types inherited from BoundingVolume
enum | BoundsType { BT_default , BT_best , BT_sphere , BT_box , BT_fastest }
enum | IntersectionFlags { IF_no_intersection = 0 , IF_possible = 0x01 , IF_some = 0x02 , IF_all = 0x04 , IF_dont_understand = 0x08 }

## Detailed Description

An axis-aligned bounding box; that is, a minimum and maximum coordinate triple.

This box is always axis-aligned. If you need a more general bounding box, try BoundingHexahedron.

Definition at line 29 of file boundingBox.h.

## Constructor & Destructor Documentation

## ◆ BoundingBox() [1/2]

BoundingBox::BoundingBox | ( |  | ) |
| inline

Constructs an empty box object.

Definition at line 17 of file boundingBox.I.

Referenced by as_bounding_box().

## ◆ BoundingBox() [2/2]

BoundingBox::BoundingBox | ( | const LPoint3 & | min,
|  | const LPoint3 & | max )
| inline explicit

Constructs a specific box object.

Definition at line 24 of file boundingBox.I.

## Member Function Documentation

## ◆ as_bounding_box()

const BoundingBox * BoundingBox::as_bounding_box | ( |  | ) | const
| virtual

Virtual downcast method.

Returns this object as a pointer of the indicated type, if it is in fact that type. Returns NULL if it is not that type.

Reimplemented from BoundingVolume.

Definition at line 131 of file boundingBox.cxx.

References BoundingBox().

## ◆ force_init_type()

virtual TypeHandle BoundingBox::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from FiniteBoundingVolume.

Definition at line 112 of file boundingBox.h.

## ◆ get_approx_center()

LPoint3 BoundingBox::get_approx_center | ( |  | ) | const
| virtual

Implements GeometricBoundingVolume.

Definition at line 84 of file boundingBox.cxx.

## ◆ get_class_type()

static TypeHandle BoundingBox::get_class_type | ( |  | ) |
| inline static

Definition at line 101 of file boundingBox.h.

## ◆ get_max()

LPoint3 BoundingBox::get_max | ( |  | ) | const
| virtual

Implements FiniteBoundingVolume.

Definition at line 60 of file boundingBox.cxx.

## ◆ get_maxq()

const LPoint3 & BoundingBox::get_maxq | ( |  | ) | const
| inline

An inline accessor for the maximum value.

get_max() would also work, but it is a virtual non-inline method.

Definition at line 51 of file boundingBox.I.

References BoundingVolume::is_empty(), and BoundingVolume::is_infinite().

## ◆ get_min()

LPoint3 BoundingBox::get_min | ( |  | ) | const
| virtual

Implements FiniteBoundingVolume.

Definition at line 50 of file boundingBox.cxx.

## ◆ get_minq()

const LPoint3 & BoundingBox::get_minq | ( |  | ) | const
| inline

An inline accessor for the minimum value.

get_min() would also work, but it is a virtual non-inline method.

Definition at line 40 of file boundingBox.I.

References BoundingVolume::is_empty(), and BoundingVolume::is_infinite().

## ◆ get_type()

virtual TypeHandle BoundingBox::get_type | ( |  | ) | const
| inline virtual

Reimplemented from FiniteBoundingVolume.

Definition at line 109 of file boundingBox.h.

## ◆ get_volume()

PN_stdfloat BoundingBox::get_volume | ( |  | ) | const
| virtual

Reimplemented from FiniteBoundingVolume.

Definition at line 70 of file boundingBox.cxx.

## ◆ init_type()

static void BoundingBox::init_type | ( |  | ) |
| inline static

Definition at line 104 of file boundingBox.h.

## ◆ make_copy()

BoundingVolume * BoundingBox::make_copy | ( |  | ) | const
| virtual

Implements BoundingVolume.

Definition at line 42 of file boundingBox.cxx.

## ◆ output()

void BoundingBox::output | ( | std::ostream & | out | ) | const
| virtual

Implements BoundingVolume.

Definition at line 116 of file boundingBox.cxx.

## ◆ set_min_max()

void BoundingBox::set_min_max | ( | const LPoint3 & | min,
|  | const LPoint3 & | max )
| inline

Sets the min and max point of the rectangular solid.

Definition at line 101 of file boundingBox.I.

## ◆ xform()

void BoundingBox::xform | ( | const LMatrix4 & | mat | ) |
| virtual

Implements GeometricBoundingVolume.

Definition at line 94 of file boundingBox.cxx.

## Friends And Related Symbol Documentation

## ◆ BoundingSphere

friend class BoundingSphere
| friend

Definition at line 117 of file boundingBox.h.

## Member Data Documentation

## ◆ get_num_planes

int BoundingBox::get_num_planes
| inline

Returns 6: the number of faces of a rectangular solid.

Definition at line 54 of file boundingBox.h.

## ◆ get_num_points

int BoundingBox::get_num_points
| inline

Returns 8: the number of vertices of a rectangular solid.

Definition at line 51 of file boundingBox.h.

## ◆ get_plane

LPlane BoundingBox::get_plane
| inline

Returns the nth face of the rectangular solid.

Definition at line 54 of file boundingBox.h.

## ◆ get_point

LPoint3 BoundingBox::get_point
| inline

Returns the nth vertex of the rectangular solid.

Definition at line 51 of file boundingBox.h.

The documentation for this class was generated from the following files:

- panda/src/mathutil/boundingBox.h
- panda/src/mathutil/boundingBox.cxx
- panda/src/mathutil/boundingBox.I